
import Tuple;
import Dimensions;
import Rectangle;
import Polygon;
import Bounds;
import Actor;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;

public class Paddle extends Actor
   implements KeyListener, MouseMotionListener
   {
   /*
   Define an actor to represent a user-controlled paddle.
   */

   //this paddle looks like a rectangle, and it has a color
   private Rectangle rectangle;
   private final Color color;

   //all paddles have a reaction speed to respond to key presses
   private final static int REACTION_SPEED = 40;

   public Paddle(Rectangle rectangle, Color color)
      {
      /*
      Initialize this paddle with the given values.
      */

      super(null);

      this.rectangle = new Rectangle(
         new Tuple(rectangle.getX(), rectangle.getY()),
         new Dimensions(rectangle.getWidth(), rectangle.getHeight()));
      this.color = color;
      }

   public void act() {}
   public void handleCollision(Actor actor) {}
   public void handleCollision(Polygon perimeter) {}

   public boolean isMobile()
      {
      /*
      Report whether this paddle is mobile.
      */

      return false;
      }

   public Bounds getBounds()
      {
      /*
      Report this paddle's bounds.
      */

      return new Bounds(rectangle);
      }

   public void paint(Graphics smartTablet)
      {
      /*
      Paint this paddle on the given smartTablet.
      */

      int left = (int) rectangle.getX();
      int top = (int) rectangle.getY();
      int width = (int) rectangle.getWidth();
      int height = (int) rectangle.getHeight();

      smartTablet.setColor(color);
      smartTablet.fillRect(left, top, width, height);
      }

   public void keyPressed(KeyEvent keyEvent)
      {
      /*
      Move this paddle vertically to track up or down arrow key presses.
      */

      if (keyEvent.getKeyCode() == KeyEvent.VK_UP)
         rectangle.setY(rectangle.getY() - Paddle.REACTION_SPEED);

      if (keyEvent.getKeyCode() == KeyEvent.VK_DOWN)
         rectangle.setY(rectangle.getY() + Paddle.REACTION_SPEED);
      }

   public void mouseMoved(MouseEvent mouseEvent)
      {
      /*
      Move this paddle vertically to track the mouse.
      */

      rectangle.setY(mouseEvent.getY());
      }

   //we must implement the following methods
   //to implement KeyListener and MouseListener
   public void keyReleased(KeyEvent keyEvent) {}
   public void keyTyped(KeyEvent keyEvent) {}
   public void mouseDragged(MouseEvent mouseEvent) {}
   }
