
import Tuple;
import Dimensions;
import Rectangle;
import Polygon;
import Bounds;
import Actor;

import java.awt.Color;
import java.awt.Graphics;

public class Target extends Actor
   {
   /*
   Define an actor to represent a fixed rectangular target.
   */

   //this target looks like a rectangle, and it has a color
   private final Rectangle rectangle;
   private final Color color;

   //this target has blank final location variables since it's immobile
   private final int left, top, width, height;

   public Target(Rectangle rectangle, Color color)
      {
      /*
      Initialize this target with the given values.
      */

      super(null);

      left = (int) rectangle.getX();
      top = (int) rectangle.getY();
      width = (int) rectangle.getWidth();
      height = (int) rectangle.getHeight();

      this.rectangle = new Rectangle(
         new Tuple(left, top), new Dimensions(width, height));

      this.color = color;
      }

   public void act() {}
   public void handleCollision(Actor actor) {}
   public void handleCollision(Polygon perimeter) {}

   public boolean isMobile()
      {
      /*
      Report whether this target is mobile.
      */

      return false;
      }

   public Bounds getBounds()
      {
      /*
      Report this target's bounds.
      */

      return new Bounds(rectangle);
      }

   public void paint(Graphics smartTablet)
      {
      /*
      Paint this target on the given smartTablet.
      */

      smartTablet.setColor(color);
      smartTablet.fillRect(left, top, width, height);
      }
   }
