
import Actor;

import java.util.Vector;

public class Troupe
   {
   /*
   Define an object to represent a set of actors.
   */

   //this troupe consists of a set of actors,
   //and a set of recently hired and recently fired actors
   private Vector troupe, hiredActors, firedActors;

   public Troupe()
      {
      /*
      Initialize this troupe.
      */

      troupe = new Vector();
      hiredActors = new Vector();
      firedActors = new Vector();
      }

   public void addActor(Actor actor)
      {
      /*
      Add the given actor to this troupe.
      */

      hiredActors.addElement(actor);
      }

   public void removeActor(Actor actor)
      {
      /*
      Remove the given actor from this troupe.
      */

      firedActors.addElement(actor);
      }

   public Actor getActorAt(int index)
      {
      /*
      Report this troupe's index'th actor.
      Report null if there is no such actor.
      */

      if ((index < 0) || (index > (this.getSize() - 1)))
         return null;
      else
         return (Actor) troupe.elementAt(index);
      }

   public int getSize()
      {
      /*
      Report this troupe's number of actors.
      */

      return troupe.size();
      }

   public void updateTroupe()
      {
      /*
      Clean up this troupe.
      */

      for (int index = 0; index < firedActors.size(); index++)
         troupe.removeElement(firedActors.elementAt(index));
      for (int index = 0; index < hiredActors.size(); index++)
         troupe.addElement(hiredActors.elementAt(index));

      firedActors.removeAllElements();
      hiredActors.removeAllElements();
      }
   }
