
public class Tuple
   {
   /*
   Define an object to hold a two-dimensional value.
   */

   //this tuple has an x and y value
   private double x, y;

   public Tuple(double x, double y)
      {
      /*
      Initialize this tuple with the given values.
      */

      this.x = x; this.y = y;
      }

   public final double getX()
      {
      /*
      Report this tuple's x-value.
      */

      return x;
      }

   public final void setX(double x)
      {
      /*
      Alter this tuple's x-value.
      */

      this.x = x;
      }

   public final double getY()
      {
      /*
      Report this tuple's y-value.
      */

      return y;
      }

   public final void setY(double y)
      {
      /*
      Alter this tuple's y-value.
      */

      this.y = y;
      }

   public final double distanceTo(Tuple tuple)
      {
      /*
      Report this tuple's Euclidean distance from to the given one.
      */

      double x1 = this.getX(); double y1 = this.getY();
      double x2 = tuple.getX(); double y2 = tuple.getY();
      double xSquared = (x1 - x2) * (x1 - x2);
      double ySquared = (y1 - y2) * (y1 - y2);

      return Math.sqrt(xSquared + ySquared);
      }

   public String toString()
      {
      /*
      Report this tuple's string representation.
      */

      return "[" + getX() + "," + getY() + "]";
      }
   }
